require(GlobalDependencys:GetDependency("StandardBase"):GetPackageName())

--GAME VARS
fDefaultFOV = 85
fAdditionalFOV = 0
fAspectRatio = DisplayInfo:GetWidth() / DisplayInfo:GetHeight()
fAspectRatio169 = 1.777777791
fFactor = 0.00872665
fHUDSafeZOneLeft = 0
fHUDSafeZoneRight = 0

--ControlVars
bFixEnabled = true
bFOV = true
bAspect = true
bHUDSafeZone = true
bAspect = true
bFringe = true
bDOF = true

--PROCESS VARS
Process_FriendlyName = Module:GetFriendlyName()
Process_WindowName = "*"
Process_ClassName = "UnrealWindow"
Process_EXEName = "Artemis-Win64-Shipping.exe"

--INJECTION BEHAVIOUR
InjectDelay = 500
WriteInterval = 100
SearchInterval = 100
SuspendThread = false

--Name                         Manual/Auto/Hybrid  		Steam/Origin/Any                IncludeFile:Configure;Enable;Periodic;Disable;
SupportedVersions = { 		
{"Automatically Detect",       "Hybrid",  			"Any",	                         "Configure_SignatureScan;Enable_Inject;Periodic;Disable_Inject;"},
}

function Init_Controls()

	DefaultControls.AddHeader("Header_FixesEnableDisable","Individual Fixes",245,70,210,17)
	
	DefaultControls.AddHeader("Header_FOV","FOV fine adjustment",15,70,210,17)	
	DefaultControls.AddFixedFOVSlider("FOVSlider","FOVSlider_Changed",55,100,125,35,0,120,0,1)
	FOVSlider:SetTickFrequency(10)
	FOVSlider:SetLabel1Text("-20")
	FOVSlider:SetLabel2Text("+100")
	
	DefaultControls.AddFixToggle("CKFOVFix_Enable","FOV fix","CKFOVFix_Changed",255,101,180,14)
	DefaultControls.AddFixToggle("CKAspectFix_Enable","Aspect fix","CKARFix_Changed",255,121,180,14)
	DefaultControls.AddFixToggle("CKFRINGEFix_Enable","Chromatic aberration fix","CKFRINGEFix_Changed",255,141,180,14)
	DefaultControls.AddFixToggle("CKDOFFix_Enable","Depth of field fix","CKDOFFix_Changed",255,161,180,14)
	
end

function Configure_SignatureScan() 
	
	local tAddress = HackTool:AddAddress("FOV")
	
	if HackTool:SignatureScan("C6 84 ?? ?? ?? ?? ?? ?? 48 ?? ?? 74 ?? E8 ?? ?? ?? ?? 0F",tAddress,PAGE_EXECUTE_READ,0x12,Process_EXEName) == 0 then
		return ErrorOccurred(string.format(SigScanError,tAddress:GetName()))
	else	
		print( tAddress:GetInfo(TYPE_ADDRESS) )
		--Artemis-Win64-Shipping.APlayerCameraManager::GetFOVAngle+5D - 74 05                 	- je Artemis-Win64-Shipping.APlayerCameraManager::GetFOVAngle+64
		--Artemis-Win64-Shipping.APlayerCameraManager::GetFOVAngle+5F - E8 3C EA 38 FE          - call Artemis-Win64-Shipping.FMemory::Free
		--Artemis-Win64-Shipping.APlayerCameraManager::GetFOVAngle+64 - 0F 28 C6               	- movaps xmm0,xmm6
		--Artemis-Win64-Shipping.APlayerCameraManager::GetFOVAngle+67 - 48 8B 8C 24 20 06 00 00 - mov rcx,[rsp+00000620]
		--Artemis-Win64-Shipping.APlayerCameraManager::GetFOVAngle+6F - 48 33 CC              	- xor rcx,rsp
	end
	
	local tAddress = HackTool:AddAddress("ASPECT")
	
	if HackTool:SignatureScan("C3 CC 48 ?? ?? ?? ?? 57 48 ?? ?? ?? F2 ?? ?? ?? 48 ?? ?? F2 ?? ?? ?? 48 ?? ?? 8B ?? ?? 89",tAddress,PAGE_EXECUTE_READ,0x51,Process_EXEName) ==0 then
		return ErrorOccurred(string.format(SigScanError,tAddress:GetName()))	
	else
		print( tAddress:GetInfo(TYPE_ADDRESS) )
		--Artemis-Win64-Shipping.FMinimalViewInfo::FMinimalViewInfo+49 - 89 41 28              - mov [rcx+28],eax
		--Artemis-Win64-Shipping.FMinimalViewInfo::FMinimalViewInfo+4C - 8B 42 2C              - mov eax,[rdx+2C]
		--Artemis-Win64-Shipping.FMinimalViewInfo::FMinimalViewInfo+4F - 89 41 2C              - mov [rcx+2C],eax
		--Artemis-Win64-Shipping.FMinimalViewInfo::FMinimalViewInfo+52 - 8B 41 30              - mov eax,[rcx+30]
		--Artemis-Win64-Shipping.FMinimalViewInfo::FMinimalViewInfo+55 - 33 42 30              - xor eax,[rdx+30]
	end
	
	local tAddress = HackTool:AddAddress("FRINGE")
	
	if HackTool:SignatureScan("7F ?? 89 B3 ?? ?? ?? ?? 8B ?? ?? 39 05",tAddress,PAGE_EXECUTE_READ,0x0,Process_EXEName) == 0 then
		return ErrorOccurred(string.format(SigScanError,tAddress:GetName()))
	else	
		print( tAddress:GetInfo(TYPE_ADDRESS) )
		--Artemis-Win64-Shipping.FSceneView::EndFinalPostprocessSettings+7A - 48 8B 05 EF 4B 4B 02  - mov rax,[Artemis-Win64-Shipping.exe+578ADA0]
		--Artemis-Win64-Shipping.FSceneView::EndFinalPostprocessSettings+81 - 39 30                 - cmp [rax],esi
		--Artemis-Win64-Shipping.FSceneView::EndFinalPostprocessSettings+83 - 7F 06                 - jg Artemis-Win64-Shipping.FSceneView::EndFinalPostprocessSettings+8B
		--Artemis-Win64-Shipping.FSceneView::EndFinalPostprocessSettings+85 - 89 B3 84 10 00 00     - mov [rbx+00001084],esi
		--Artemis-Win64-Shipping.FSceneView::EndFinalPostprocessSettings+8B - 8B 04 2F              - mov eax,[rdi+rbp]
	end

	local tAddress = HackTool:AddAddress("DOF")
	
	if HackTool:SignatureScan("8B ?? ?? E8 ?? ?? ?? ?? 8B ?? E8 ?? ?? ?? ?? 84 ?? 74 ?? 48",tAddress,PAGE_EXECUTE_READ,0x0,Process_EXEName) == 0 then
		return ErrorOccurred(string.format(SigScanError,tAddress:GetName()))
	else	
		print( tAddress:GetInfo(TYPE_ADDRESS) )
		--Artemis-Win64-Shipping.DiaphragmDOF::IsEnabled+30 - 48 8B 05 71 90 88 03  - mov rax,[Artemis-Win64-Shipping.exe+56D3C18]
		--Artemis-Win64-Shipping.DiaphragmDOF::IsEnabled+37 - 48 8B CB              - mov rcx,rbx
		--Artemis-Win64-Shipping.DiaphragmDOF::IsEnabled+3A - 8B 78 04              - mov edi,[rax+04]
		--Artemis-Win64-Shipping.DiaphragmDOF::IsEnabled+3D - E8 FE ED 48 01        - call Artemis-Win64-Shipping.FSceneView::GetShaderPlatform
		--Artemis-Win64-Shipping.DiaphragmDOF::IsEnabled+42 - 8B C8                 - mov ecx,eax
	end
	
	return true
end

function Enable_Inject()

	local Variables = HackTool:AllocateMemory("Variables",0)
	Variables:PushFloat("CompensatedFOV")
	Variables:PushFloat("FOVIn")
	Variables:PushFloat("FOVOut")
	Variables:PushFloat("AdditionalFOV")
	Variables:PushFloat("AspectRatio")
	Variables:PushFloat("ScreenRatio")
	Variables:PushFloat("factor")
	Variables:Allocate()
	Variables["FOVIn"]:WriteFloat(fDefaultFOV)
	Variables["FOVOut"]:WriteFloat(fDefaultFOV)
	Variables["AdditionalFOV"]:WriteFloat(fAdditionalFOV)
	Variables["AspectRatio"]:WriteFloat(fAspectRatio169)
	Variables["ScreenRatio"]:WriteFloat(fAspectRatio)
	Variables["factor"]:WriteFloat(fFactor)
	
	ResolutionChanged()	

	local asm = [[	

		(codecave:jmp)FOV,FOV_cc:
			movss [(allocation)Variables->FOVIn],$$2						$ctx=1
			fld dword ptr [(allocation)Variables->FOVIn]
			fmul dword ptr [(allocation)Variables->factor]
			fptan
			fstp st0
			fld dword ptr [(allocation)Variables->ScreenRatio]
			fdiv dword ptr [(allocation)Variables->AspectRatio]
			fmulp st1,st0
		    fld1
		    fpatan
			fdiv dword ptr [(allocation)Variables->factor]						; calculate compensated FOV
			fstp dword ptr [(allocation)Variables->CompensatedFOV]				; and retrieve it			
			movss $$2,[(allocation)Variables->CompensatedFOV]				$ctx=1
			addss $$2,[(allocation)Variables->AdditionalFOV]				$ctx=1
			movss [(allocation)Variables->FOVOut],$$2						$ctx=1
			%originalcode%
			jmp %returnaddress%
			%end%

		(codecave:jmp)ASPECT,ASPECT_cc:
			$$0 [(allocation)Variables->AspectRatio],$$2					$ctx=1
			$$0 $$2,[(allocation)Variables->ScreenRatio]					$ctx=1
			%originalcode%
			jmp %returnaddress%
			%end%
			
		(codecave)FRINGE,FRINGE_cc:
			nop
			nop
			%end%
			
		(codecave)DOF,DOF_cc:
			xor $$1,$$1														$ctx=1
			nop
			%end%
			
	]]

	if HackTool:CompileAssembly(asm,"Fixes") == nil then
		return ErrorOccurred("Assembly compilation failed...")
	else
		Toggle_CodeCave("FOV_cc",bFOV)
		Toggle_CodeCave("ASPECT_cc",bAspect)
		Toggle_CodeCave("FRINGE_cc",bFringe)
		Toggle_CodeCave("DOF_cc",bDOF)
	end	
			
	Write_FOV()
	
end

function Periodic()

	local Variables = HackTool:GetAllocation("Variables")
	
	if Variables and Variables["FOVIn"] and Variables["AdditionalFOV"] then
		local fCompensatedFOV = Variables["CompensatedFOV"]:ReadFloat()
		local fFOVIn = Variables["FOVIn"]:ReadFloat()
		local fFOVOut = Variables["FOVOut"]:ReadFloat()
		PluginViewport:AppendStatusMessage( string.format("\r\n===== Fix informations =====\r\nFOV In: %.2f, Compensated FOV: %.2f, FOV Out: %.2f", fFOVIn, fCompensatedFOV, fFOVOut))
	end
	
end

function FOVSlider_Changed(Sender)

	fAdditionalFOV = Sender:GetPosition() - 20
	lblFOVSlider.Caption:SetCaption( string.format("Value: +%.0f",fAdditionalFOV) )		
	Write_FOV()
	ForceUpdate()

end

function Write_FOV()

	local Variables = HackTool:GetAllocation("Variables")
	if Variables and Variables["AdditionalFOV"] then
		if bFOV == true then
			Variables["AdditionalFOV"]:WriteFloat(fAdditionalFOV)
		else
			Variables["AdditionalFOV"]:WriteFloat(0)
		end
	end

end

function Disable_Inject()
	
	CleanUp()
	
end

function CKFOVFix_Changed(Sender)

	bFOV = Toggle_CheckFix(Sender)
	Toggle_CodeCave("FOV_cc",bFOV)
	Write_FOV()
	ForceUpdate()
	
end

function CKARFix_Changed(Sender)

	bAspect = Toggle_CheckFix(Sender)
	Toggle_CodeCave("ASPECT_cc",bAspect)
	ForceUpdate()

end

function CKFRINGEFix_Changed(Sender)

	bFringe = Toggle_CheckFix(Sender)
	Toggle_CodeCave("FRINGE_cc",bFringe)
	ForceUpdate()

end

function CKDOFFix_Changed(Sender)

	bDOF = Toggle_CheckFix(Sender)
	Toggle_CodeCave("DOF_cc",bDOF)
	ForceUpdate()

end

function ResolutionChanged() 

	SyncDisplayDetection()
	
end

function Init()

	Init_BaseControls()
	Init_Controls()

end

function DeInit()

	DisableFix()

end
